import 'dart:async';

import 'package:apple_push_notification_service/notification_method_channel.dart';
import 'package:flutter/services.dart';

class ApplePushNotificationService {
  static String token;

  static Future<void> init({PushNotificationHandler pushNotificationHandler}) async {
    const methodChannel = MethodChannel(NotificationMethodChannel.mainChannel);

    methodChannel.setMethodCallHandler((MethodCall call) async {
      switch (call.method) {
        case NotificationMethodCall.didRegisterForRemoteNotificationsWithDeviceToken:
          token = call.arguments;
          break;
        case NotificationMethodCall.didSelectNotification:
          final payload = Map<String, dynamic>.from(call.arguments);
          pushNotificationHandler.call(payload);
          break;
      }
    });

    await methodChannel.invokeMethod(NotificationMethodCall.didInitMainChannel);
  }
}
